/*
 * GLOBAL VARIABLES. They are declared EXTERN, which means extern. global
 * storage for all variables is done in _one_ source file (initialize.c)
 * 
 * Distributed under terms of the GNU General Public License, see "copying"
 * 
 * (C) 1993, 1994 Han-Wen Nienhuys <hanwen@stack.urc.tue.nl>
 */

/* resolution */
EXTERN unsigned int xres,
                yres;

EXTERN int      noo;		/* number of objects at toplevel */
EXTERN int      max_trace_level;/* maximum trace level */

EXTERN int      tries,		/* number of tries per pixel */
                iter_override;	/* number of tries set from commandline  */

/* time information */
EXTERN double   time1,
                time2;		/* time limits */
EXTERN double   Time;		/* current time */



/* statistics */
EXTERN struct global_stat_struc global_stats;
EXTERN struct line_stat_struc line_stats;

EXTERN long int test_stat,	/* variable for debugging and testing */
                debug_options;
EXTERN int      test_flag;

#define DEBUGTOK	0x01	/* print tokens as they are read */
#define DEBUGPARS	0x02	/* turn yydebug on */
#define DEBUGRUNTIME	0x04	/* print memory statistics if something is
				 * alloced. */
#define DEBUGDECL	0x08	/* print everything in memory before
				 * tracing and after parsing */

EXTERN bool
                keyboard_exit,	/* allow early break via keypress? */
                continue_flag,	/* continue picture? */
                silent_mode
               ;

EXTERN FILE    *error_out;	/* for putting errors in */

EXTERN color    background_color;	/* the background color */

EXTERN struct camera *thecamera;/* our current camera; there can only be
				 * one. */

EXTERN double   tmpdouble;	/* for the vector macros */
EXTERN vector   tmpvector;	/* just something ..  (hhwaah) */
EXTERN double   tolerance;	/* tolerance for intersection */
EXTERN double   Aalias_width,	/* pixel width for AA  */
                depth_cutoff;	/* adaptive depth cutoff threshold */

EXTERN int      bunching;
EXTERN vector   fudge,
                bggradient;


/* shading info */
EXTERN int      shading_model;
EXTERN color    ambient_light;
EXTERN double  *global_ior;
EXTERN double   atmosphere_ior;
EXTERN int      ior_depth;



/* the list of things in the scene */
EXTERN object  *first_light,	/* chain of lights, so lights can be
				 * scanned quickly while shading */
               *thescene;	/* the scene itself. It is a composite
				 * object. Everything in the scene is
				 * contained in it. */
